﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace QuakeCharsetUtility
{
    public partial class Form1 : Form
    {
        // This is a list of type byte.  It is like an array - but I can add/remove from it at any time.
        List<byte> outputDynamicArray;

        // The form's constructor. This gets called when the form is instantiated
        public Form1()
        {
            // InitializeComponent is automatically generated by the desiner
            InitializeComponent();

            // Create a new instance of the Byte List (it will be empty)
            outputDynamicArray = new List<byte>();
        }

        // This method was automatically generated by the desinger (Properties/events panel - double clicking on the event)
        private void characterMapView1_CharacterClick(object sender, CharacterMapView.CharacterEventArgs e)
        {
            // Append one byte to the character array
            outputDynamicArray.Add(e.CharacterByte);
            UpdateOutputs();
        }

        private void UpdateOutputs()
        {
            List<char> characterList = new List<char>();

            // We're going to cast each byte to a char type, then convert it to a static array, then create a string from it.
            // Could probably do Encoding.ASCII.GetString() as well.. but meh!
            for(int i = 0; i < outputDynamicArray.Count;i++)
            {
                characterList.Add((char)outputDynamicArray[i]);
            }

            string resultForOutput = new string(characterList.ToArray());

            textBox1.Text = resultForOutput;
        }

        private void UpdateFromOutputs()
        {
            // So - this should be triggered when editing the text area...
        }

        // This method was also automatically generated by the designer (Double clicking on the button automatically creates a method linked to the Click event)
        private void button1_Click(object sender, EventArgs e)
        {
            PromptSaveFileDialog();
        }

        // Obvious!
        private void PromptSaveFileDialog()
        {
            // .Net makes it really easy to save files...
            SaveFileDialog saveFileDialog = new SaveFileDialog();

            // Call Show DIalog - when it finishes, it will return a DialogResult value which we want to make sure is OK before we proceed saving the file.
            if (saveFileDialog.ShowDialog() == System.Windows.Forms.DialogResult.OK)
            {
                string saveFileLocation = saveFileDialog.FileName;

                File.WriteAllBytes(saveFileLocation, outputDynamicArray.ToArray());
            }
        }
    }
}
